module PackageCloud
  class Repository < Object
    def initialize(attrs, config)
      @attrs = attrs
      @config = config
    end

    def create_package(file_path, dist_id)
      file_data = File.new(file_path, 'rb')
      base_url = @config.base_url 
      url = base_url + paths["create_package"]
      begin
        RestClient.post(url, :package => {:package_file      => file_data,
                                          :distro_version_id => dist_id})
        print "success!\n".green
      rescue RestClient::UnprocessableEntity => e
        print "error:\n".red
        json = JSON.parse(e.response)
        json.each do |k,v|
          puts "\n\t#{k}: #{v.join(", ")}\n"
        end
        puts ""
        exit(1)
      end
    end

    def install_script(type)
      url = urls["install_script"].gsub(/:package_type/, type)
      RestClient.get(url)
    end

    def master_tokens
      url = @config.base_url + paths["master_tokens"]
      attrs = JSON.parse(RestClient.get(url))
      attrs.map { |a| MasterToken.new(a, @config) }
    end

    def create_master_token(name)
      url = @config.base_url + paths["create_master_token"]
      begin
        RestClient.post(url, :master_token => {:name => name})
      rescue RestClient::UnprocessableEntity => e
        print "error:\n".red
        json = JSON.parse(e.response)
        json.each do |k,v|
          puts "\n\t#{k}: #{v.join(", ")}\n"
        end
        puts ""
        exit(1)
      end
    end

    def private_human
      send(:private) ? "private".red : "public".green
    end
  end
end
